# coding: utf-8


"""
IGNORE:
    Nutanix Dataprotection Versioned APIs

    Business Continuity with full spectrum of Disaster Recovery and Backup solution. Spanning across Single PC, Cross AZ, MultiSite. Configuration of Recovery points, Protection policies, Recovery Plans. Execution and monitoring of back up and recovery orchestrations on OnPrem as well as Cloud.  # noqa: E501

    OpenAPI spec version: 4.0.1-alpha-4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_dataprotection_py_client.models.dataprotection.v4.config.DataProtectionSiteReference import DataProtectionSiteReference  # noqa: F401,E501

class RecoveryPointReplicationSpec(DataProtectionSiteReference):

    """External identifier of the cluster and the Prism Central where the Recovery point should be replicated.

    :param target_availability_zone_id: (:attr:`target_availability_zone_id`) Target availability zone reference for the entities to be replicated.
    :type target_availability_zone_id: 
    :param target_cluster_id: (:attr:`target_cluster_id`) Details of the Cluster reference in the target availability zone for the entities to be replicated.
    :type target_cluster_id: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'target_availability_zone_id': 'str',
        'target_cluster_id': 'str',
        'pc_ext_id': 'str',
        'cluster_ext_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'target_availability_zone_id': 'targetAvailabilityZoneId',
        'target_cluster_id': 'targetClusterId',
        'pc_ext_id': 'pcExtId',
        'cluster_ext_id': 'clusterExtId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, target_availability_zone_id=None, target_cluster_id=None, pc_ext_id=None, cluster_ext_id=None, *args, **kwargs):  # noqa: E501
        DataProtectionSiteReference.__init__(self, pc_ext_id, cluster_ext_id, *args, **kwargs)
        self.__target_availability_zone_id = None
        self.__target_cluster_id = None
        self.discriminator = None
        if target_availability_zone_id is not None:
            self.__target_availability_zone_id = target_availability_zone_id
        if target_cluster_id is not None:
            self.__target_cluster_id = target_cluster_id

    def _initialize_object_type(self):
        return 'dataprotection.v4.config.RecoveryPointReplicationSpec'

    def _initialize_fq_object_type(self):
        return 'dataprotection.v4.r0.a4.config.RecoveryPointReplicationSpec'


    @property
    def target_availability_zone_id(self):
        """
        Target availability zone reference for the entities to be replicated.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__target_availability_zone_id

    @target_availability_zone_id.setter
    def target_availability_zone_id(self, target_availability_zone_id):

        self.__target_availability_zone_id = target_availability_zone_id

    @property
    def target_cluster_id(self):
        """
        Details of the Cluster reference in the target availability zone for the entities to be replicated.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__target_cluster_id

    @target_cluster_id.setter
    def target_cluster_id(self, target_cluster_id):

        self.__target_cluster_id = target_cluster_id

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(RecoveryPointReplicationSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RecoveryPointReplicationSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

